Re: Strange RE engine breakage in 5_61
[p5sagit/p5-mst-13.2.git] / t / io / pipe.t
index 13db20b..826cf74 100755 (executable)
@@ -1,19 +1,17 @@
 #!./perl
 
-# $RCSfile: pipe.t,v $$Revision: 4.1 $$Date: 92/08/07 18:27:31 $
-
 BEGIN {
     chdir 't' if -d 't';
-    @INC = '../lib';
+    unshift @INC, '../lib';
     require Config; import Config;
     unless ($Config{'d_fork'}) {
-       print "1..0\n";
+       print "1..0 # Skip: no fork\n";
        exit 0;
     }
 }
 
 $| = 1;
-print "1..14\n";
+print "1..15\n";
 
 # External program 'tr' assumed.
 open(PIPE, "|-") || (exec 'tr', 'YX', 'ko');
@@ -61,6 +59,7 @@ if ($^O eq 'vmesa') {
        exec 'echo', 'not ok 6';
     }
 }
+wait;                          # Collect from $pid
 
 pipe(READER,WRITER) || die "Can't open pipe";
 close READER;
@@ -134,7 +133,6 @@ else {
 }
 
 # check that status for the correct process is collected
-wait;                          # Collect from $pid
 my $zombie = fork or exit 37;
 my $pipe = open *FH, "sleep 2;exit 13|" or die "Open: $!\n";
 $SIG{ALRM} = sub { return };
@@ -158,3 +156,16 @@ if ($? == 37*256 && $wait == $zombie && ! $!) {
   print (((open P, "|    " ) ? "not " : ""), "ok 13\n");
   print (((open P, "     |" ) ? "not " : ""), "ok 14\n");
 }
+
+# check that status is unaffected by implicit close
+{
+    local(*NIL);
+    open NIL, '|exit 23;' or die "fork failed: $!";
+    $? = 42;
+    # NIL implicitly closed here
+}
+if ($? != 42) {
+    print "# status $?, expected 42\nnot ";
+}
+print "ok 15\n";
+$? = 0;